#include "Maiden_struct.h"
#include "Maiden_funct.h" // PAD 151008
#include "Constants.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#ifdef __APPLE__
#include "malloc.h"
#else
#include <malloc.h>
#endif

int TRC_iso(meteo_struct *meteo,d18O_struct *d18O,d2H_struct *d2H,
	    photo_struct *photo,d13C_struct *d13C,allocation_struct *alloc,int i, const param_struct *par)
{
  int ok=1;
    int y;
    
    //year
     y = meteo->year[i];
    
  /* ------------------------ code history ------------------------------
     Isotopes in Tree Ring Cellulose

  */
    
    
  //* ------------------ input/output local variables --------------------
  double RH,d13CTRC_new,d13C_photosynthese; // d13C_DTRC_sun,d13C_DTRC_shade, FG
  double d18Ov;
  double d18Oxw;
  //double ff_d18O, ff_d13C; FG
  //double TK_air; FG
  double TK_leaf, RH_leaf;

  RH     = meteo->rh[i];
  //RH     = meteo->rhavg[i];
  d18Ov  = d18O->vapor[i];
  d18Oxw = d18O->xylem[i];

  //TK_air = meteo->s_tday[i]+273.15; FG
  //TK_air = meteo->s_tavg[i]+273.15;

  /*Following Linacre [1964], and in the absence of a species-speciﬁc equation,
    we estimate leaf temperature as a linear function of air temperature:
    Tleaf = 23./33.*Tair+10.  with T in Celcius
    where constants are empirically-determined (Evans et al., 2007) */

  TK_leaf = 21.4+273.15; // 19.2~23.6 Helliker and Richter, 2008 PAD 170609
  //TK_leaf = TK_air;
    
    
  RH_leaf = RH; // P_sat1(TK_air)/P_sat1(TK_leaf) ;

  

  /********************************************
       Daily Oxygen-isotopes ratio in TRC
  ********************************************/

  d18O->TRC[i] = Anderson(d18Oxw, d18Ov, TK_leaf, RH_leaf, par->ff_d18O,par->Eps_bio,par->Eps_Kin);
 
    // Weighting of TRCnew and CCi_CO2_leaf with Cstem
         
         d18O->TRC_y[y-year0]                += (d18O->TRC[i]*alloc->inC_stem[i-1]);
         d18O->xylem_y[y-year0]                += (d18O->xylem[i]*alloc->inC_stem[i-1]);
         d18O->vapor_y[y-year0]                += (d18O->vapor[i]*alloc->inC_stem[i-1]);

    

  /********************************************
       Daily Hydrogen-isotopes ratio in TRC
  ********************************************/

    
  /********************************************
       Daily Carbon-isotopes ratio in TRC
  ********************************************/
    
// 1- Calculation of discrimination against 13C (permil)
    
  if (photo->A_canopy[i] == 0.)
    {
      d13C->CCi_CO2[i] = 0.;
      d13C->DTRC[i] = -9999.;
    }
  else
    {
        // Note that: photo->Ci_sun[i] = photo->Ci_shade[i]
        
        d13C->CCi_CO2[i]= photo->Ci_sun[i] * 1000000 /meteo->s_pa[i] ; //from [Pa] to [ppmV]
        
        // a- Calculated following Farquhar et al. (1982) model with photorespiratory effect (Lavergne et al. 2020)
        d13C->DTRC[i] = Lavergne_isoC3(meteo->s_CO2[i], d13C->CCi_CO2[i], meteo->s_tday[i], meteo->s_pa[i]);
        
        // b- Calculated as in Danis et al. (2012)
       //   d13C->DTRC[i] = Hatte_isoC3(meteo->s_CO2[i], d13C->CCi_CO2[i], meteo->s_tday[i]);
    }
    
    
 // 2- Calculation carbon isotopic composition of carbon stored
  if (i == 0)
  {
      d13C->stor[i]= -21.0; // [PerMil] d13C->CO2[i];
      
  //    d13C->TRCnew_y[y-year0]        = 0;
  //    d13C->CCi_CO2_y[y-year0]       = 0;
  //    d13C->CCa_CO2_y[y-year0]       = 0;
  }
    
   // double d13CO2 = (-0.01362 * meteo->s_CO2[i] - 3.00783);  // Regression model between CO2 and d13CO2 based on Mauna Loa data over 1980-2018

    if (i >= 1)
    {
        //if (d13C->DTRC[i] != -9999. and alloc->C_stor[i] > 0. and alloc->inC_stor[i-1] > 0.)
        if (d13C->DTRC[i] != -9999. and alloc->inC_stor[i-1] > 0.)  // Carbon stored at the timestep
        {
            d13C_photosynthese = ( d13C->d13CO2[i] -d13C->DTRC[i])/(1+d13C->DTRC[i]/1000.);
            d13C->stor[i] = (d13C->stor[i-1]*(alloc->C_stor[i]-alloc->inC_stor[i-1]) + d13C_photosynthese*alloc->inC_stor[i-1]) / alloc->C_stor[i] ;

        }

        //if ((d13C->DTRC[i] != -9999. and alloc->C_stor[i] == 0. ) or d13C->DTRC[i] == -9999.)
        else
        {
            d13C->stor[i] = d13C->stor[i-1];  // No carbon stored at the timestep

        }

 // 3- Calculation carbon isotopic composition of tree rings
        
        if (d13C->DTRC[i] != -9999.)
        {
            d13C_photosynthese = ( d13C->d13CO2[i] -d13C->DTRC[i])/(1+d13C->DTRC[i]/1000.);

            // a- Formulation proposed by FG
            if (alloc->outC_stor[i-1] > 0)
            {
             
                d13CTRC_new = (alloc->A_net[i-1]* (d13C_photosynthese + par->Dc_p) + alloc->outC_stor[i-1]*(d13C->stor[i] + par->Dst_dest + par->Dc_p))/
                (alloc->A_net[i-1]+alloc->outC_stor[i-1]);
            }
            else
            {
            // Adding post-photosynthetic fractionations between leaf and tree-ring wood (cellulose or bulk wood)
                d13CTRC_new = d13C_photosynthese + par->Dc_p;
            }
            d13C->TRCnew[i]= d13CTRC_new; // FG changed
            
            // b- Old formulation in Danis et al. (2012) with ff_d13C calibrated parameter

            // d13C->TRCnew[i]= par->ff_d13C*d13C->stor[i] + (1.-par->ff_d13C)*(d13CTRC_new);

        }
        else
        {
            if (d13C->DTRC[i] == -9999. and alloc->C_stor[i] > 0. )
                { d13C->TRCnew[i] = d13C->stor[i] + par->Dst_dest + par->Dc_p; } // FG changed
            else
                { d13C->TRCnew[i] = -9999.; }
        }
        
        
        
     }

 
    // Weighting of TRCnew and CCi_CO2_leaf with Cstem

      if (d13C->DTRC[i] != -9999.)
             {
                 d13C->DTRC_y[y-year0]               += d13C->DTRC[i]*alloc->inC_stem[i-1];
             }
      
      d13C->TRCnew_y[y-year0]                += (d13C->TRCnew[i]*alloc->inC_stem[i-1]);
      d13C->CCi_CO2_y[y-year0]                += (d13C->CCi_CO2[i]*alloc->inC_stem[i-1]);
      d13C->CCa_CO2_y[y-year0]                += (meteo->s_CO2[i]*alloc->inC_stem[i-1]);
      d13C->d13CO2_y[y-year0]                += d13C->d13CO2[i];
      d13C->Cratio_y[y-year0]    = d13C->CCi_CO2_y[y-year0]/d13C->CCa_CO2_y[y-year0];

    
    
  //***************************************************************
  return (!ok);}

